---
name: Bug report
about: Create a report to help us improve
title: "[BUG] (Add a descriptive title here)"
labels: 'Bug'
assignees: 'mitchellkrogza'

---

## Describe the bug

A clear and concise description of what the bug is.

## To Reproduce

Steps to reproduce the behavior:

## Expected behavior

A clear and concise description of what you expected to happen.

## Screenshots

If applicable, add screenshots to help explain your problem.

## Copy of nginx.conf

If applicable please paste your nginx.conf file here
(paste in between the ```     ``` markers)

```

Paste nginx.conf here

```

## Copy of vhost / website / host .conf file

If applicable please paste your site/vhost configuration file in between the code ticks
(paste in between the ```     ``` markers)

```

Paste site config here

```

## Server (please complete the following information):
 
 - Operating System: 

 - [ ] Ubuntu
 - [ ] Alpine
 - [ ] Arch Linux
 - [ ] Debian
 - [ ] CentOS
 - [ ] Fedora
 - [ ] Deepin
 - [ ] Windows
 - [ ] Other


- Specify Exact Version of OS: 

```

Post output of uname -a here

```

 
 - Nginx Version [post output of sudo nginx -v]

```

Paste output of `sudo nginx -V` here (paste in between the ```     ``` markers)

```

 - Other Environments [include Version information]
 - [ ] Plesk
 - [ ] CPanel
 - [ ] Synology NAS
 - [ ] Other
 - Specify Other / Specific Version Information Here: 

 - Any other applicable log / error messages that may help us to help you.

```

Paste any log / error messages here (paste in between the ```     ``` markers)

```

## Additional information

Add any other context about the problem here.

